"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkspaceSymbol = void 0;
const lsp = __importStar(require("vscode-languageserver"));
class WorkspaceSymbol {
    constructor(_symbols) {
        this._symbols = _symbols;
    }
    register(connection) {
        connection.client.register(lsp.WorkspaceSymbolRequest.type);
        connection.onRequest(lsp.WorkspaceSymbolRequest.type, this.provideWorkspaceSymbols.bind(this));
    }
    async provideWorkspaceSymbols(params) {
        const result = [];
        await this._symbols.update();
        const all = this._symbols.definitions.query(Array.from(params.query));
        for (let [, symbols] of all) {
            result.push(Array.from(symbols));
        }
        return result.flat();
    }
}
exports.WorkspaceSymbol = WorkspaceSymbol;
