"use strict";
/*---------------------------------------------------------------------------------------------
 *  Copyright (c) Microsoft Corporation. All rights reserved.
 *  Licensed under the MIT License. See License.txt in the project root for license information.
 *--------------------------------------------------------------------------------------------*/
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const languages_1 = __importDefault(require("../languages"));
const utils_1 = require("./utils");
suite('Queries', function () {
    suiteSetup(async function () {
        await utils_1.bootstrapWasm();
    });
    const types = ['comments', 'folding', 'identifiers', 'locals', 'outline', 'references'];
    for (let type of types) {
        test(type, function () {
            const languages = languages_1.default.allAsSelector();
            for (let languageId of languages) {
                try {
                    const q = languages_1.default.getQuery(languageId, type, true);
                    assert_1.default.ok(q);
                }
                catch (err) {
                    assert_1.default.fail(`INVALID ${languageId}/ ${type}`);
                }
            }
        });
    }
});
